> ## Documentation Index
> Fetch the complete documentation index at: https://kb.talostrading.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Asset metrics

> Returns requested metrics for specified assets.<br/><br/> Results for block by block metrics (`1b` frequency) are ordered by tuple `(asset, height, block_hash)`, all other metrics are ordered by tuple `(asset, time)`. You can change the sorting using `sort` query parameter.<br/><br/> Supported output formats are `json` (default), `json_stream` and `csv`. Use the `format` query parameter to override it.<br/> To fetch the next page of results use `next_page_url` JSON response field or `x-next-page-url` CSV HTTP header if present.<br/><br/> If multiple metrics are requested in the same time the strict policy for partially available metrics among requested ones is applied: <ul>
  <li>missing metric name in the JSON response means that the metric is "not a supported metric" for the asset and frequency while some other requested metrics are supported.</li>
  <li>`null` value of the metric means "no data in the database" while some other requested metrics have data.</li>
</ul>



## OpenAPI

````yaml /coinmetrics/openapi/coinmetrics.yaml get /timeseries/asset-metrics
openapi: 3.0.2
info:
  title: Coin Metrics API v4
  description: >-
    [Coin Metrics Homepage](https://coinmetrics.io/)<br/> [API Backward
    Compatibility
    Policy](https://docs.coinmetrics.io/access-our-data/api#backward-compatibility)<br/>
    [Python API
    Client](https://coinmetrics.github.io/api-client-python/site/index.html)<br/><br/>

    HTTP API root endpoint URL is `https://api.coinmetrics.io/v4`. Coin
    Metrics&apos; paid product.<br/> WebSocket API root endpoint is
    `wss://api.coinmetrics.io/v4`. Coin Metrics&apos; paid product.<br/><br/>
    The Community HTTP API root endpoint URL is
    `https://community-api.coinmetrics.io/v4`. API key is not required when
    accessing community endpoints. Available to the community under the
    [Creative Commons](https://creativecommons.org/licenses/by-nc/4.0/) license.

    # Authentication

    <!-- ReDoc-Inject: <security-definitions> -->

    # Response headers

    Note that Coin Metrics API responses have a `CF-RAY` HTTP header e.g.
    `88a6ec1d2f930774-IAD` which can be used for diagnostic purposes. When
    raising Support requests, please ensure to provide the value of this
    header. 
  termsOfService: https://coinmetrics.io/api/terms
  contact:
    name: Coin Metrics Support
    url: https://coinmetrics.io/support/
    email: support@coinmetrics.io
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0.html
  version: 4.0.0
servers:
  - url: https://api.coinmetrics.io/v4
  - url: wss://api.coinmetrics.io/v4
  - url: https://community-api.coinmetrics.io/v4
security: []
tags:
  - name: Rate limits
    description: >-
      To ensure the quality of Coin Metrics services, API is subject to rate
      limiting.<br/> <table> <tr><th>Rate Limit Plan</th><th>REST API: Requests
      per Second (sliding window)</th><th>REST API: Download Speed</th><th>REST
      API: Max Parallel Requests</th><th>WebSocket API: Max Parallel
      Connections</th></tr> <tr><td>Community</td><td>10 requests per 6 seconds
      per IP address</td><td>Reduced speed</td><td>10</td><td>N/A</td></tr>
      <tr><td>Trial</td><td>10 requests per 6 seconds per API key</td><td>Max
      speed</td><td>10</td><td>200</td></tr> <tr><td>Default (PRO)</td><td>6000
      requests per 20 seconds per API key</td><td>Standard
      speed</td><td>10</td><td>200</td></tr> <tr><td>Download (PRO)</td><td>6000
      requests per 20 seconds per API key</td><td>Max
      speed</td><td>10</td><td>200</td></tr> </table> <br/> All PRO keys by
      default get the "default" rate limits. To download historical data at max
      speed, you need to switch to the "download" plan. <br/> <br/> The paid and
      community versions of the API have a limit of 10 parallel REST API
      requests. After this limit is reached, further parallel requests will be
      queued, so performance will be slower.<br/> <br/> If you reach the
      request-per-second limit, API starts to return `429 Too Many Requests`
      HTTP response status.<br/> API also provides `X-RateLimit-*` response
      headers formatted according to
      https://tools.ietf.org/html/draft-polli-ratelimit-headers-03.<br/>
      Additionally, the API provides the `X-RateLimit-Plan` header which
      indicates the current rate limiting plan. This header may have values:
      `default`, `trial`, `download`, or `community`.
    x-cm-gitbook:
      foldIntoInfo: true
  - name: Reference Data
    description: Metadata information of entities supported by Coin Metrics.
    x-cm-gitbook:
      tag: Meta Data
      icon: book
  - name: Catalog
    x-displayName: Catalog (deprecated)
    description: >-
      Catalog of available for your `api_key` data.<br/> Use the [Full
      catalog](#tag/Full-catalog) endpoints for the full list of supported by
      Coin Metrics data. <br/>DEPRECATED: See
      https://coinmetrics.io/important-changes-to-coin-metrics-api-catalog-endpoints/.
    x-cm-gitbook:
      remove: true
  - name: Catalog v2
    description: >-
      Catalog of available for your `api_key` data.<br/> Use the [Full catalog
      V2](#tag/Full-catalog-v2) endpoints for the full list of supported by Coin
      Metrics data.
    x-cm-gitbook:
      icon: list-check
  - name: Full catalog
    x-displayName: Full catalog (deprecated)
    description: >-
      The Full catalog returns the full range of data that is supported by Coin
      Metrics across all our products.<br/> If you are a client looking to
      understand the data that is available for your API key and data license,
      please use the [Catalog](#tag/Catalog) endpoint. <br/>DEPRECATED: See
      https://coinmetrics.io/important-changes-to-coin-metrics-api-catalog-endpoints/.
    x-cm-gitbook:
      remove: true
  - name: Full catalog v2
    description: >-
      The Full catalog returns the full range of data that is supported by Coin
      Metrics across all our products.<br/> If you are a client looking to
      understand the data that is available for your API key and data license,
      please use the [Catalog](#tag/Catalog-v2) endpoint.
    x-cm-gitbook:
      tag: Catalog v2
      icon: layer-group
  - name: Timeseries
    description: >-
      Endpoints for fetching metrics, market data, indexes and other time series
      data.
    x-cm-gitbook:
      icon: chart-line
      renameOperationsTo: Timeseries REST
  - name: Timeseries stream
    description: >-
      WebSocket endpoints for getting a real-time stream of metrics, market
      data, indexes and other time series data.
    x-cm-gitbook:
      tag: Timeseries
      icon: wifi
  - name: Taxonomy
    description: Taxonomy endpoints
    x-cm-gitbook:
      icon: sitemap
  - name: Taxonomy Metadata
    description: Taxonomy Metadata endpoints
    x-cm-gitbook:
      tag: Taxonomy
      icon: tags
  - name: Profile
    description: Profile endpoints
    x-cm-gitbook:
      tag: Meta Data
      icon: id-card
  - name: List of blockchain entities v2
    description: Endpoints for fetching lists of blockchain entities.
    x-cm-gitbook:
      tag: ATLAS
      icon: list
  - name: Full blockchain entities v2
    description: Endpoints for fetching full blockchain entities.
    x-cm-gitbook:
      tag: List of blockchain entities v2
      icon: database
  - name: Jobs
    description: Jobs API endpoints
    x-cm-gitbook:
      tag: ATLAS
      icon: briefcase
  - name: Blockchain Explorer Job
    description: Endpoints for creating async jobs for blockchain entities.
    x-cm-gitbook:
      tag: ATLAS
      icon: clock
  - name: Blockchain Explorer Job Results
    description: Schema definitions of results of Blockchain Explorer Job endpoints.
    x-cm-gitbook:
      foldInto: Blockchain Explorer Job
  - name: Chain Monitor tools
    description: Endpoints for working with chain monitor data.
    x-cm-gitbook:
      tag: ATLAS
      icon: wrench
  - name: Security Master
    description: Security Master endpoints
    x-cm-gitbook:
      tag: Meta Data
      icon: shield
  - name: Constituent Snapshots
    description: Endpoints for getting the snapshots of various constituents
    x-cm-gitbook:
      tag: Meta Data
      icon: camera
  - name: Constituent Timeframes
    description: Endpoints for getting the timeframes of various constituents
    x-cm-gitbook:
      tag: Meta Data
      icon: calendar
  - name: Blockchain Metadata
    description: Blockchain metadata endpoints
    x-cm-gitbook:
      tag: Meta Data
      icon: database
  - name: Meta Data
    x-cm-gitbook:
      icon: database
  - name: ATLAS
    x-cm-gitbook:
      icon: map
  - name: Timeseries REST
    x-cm-gitbook:
      tag: Timeseries
      icon: table
paths:
  /timeseries/asset-metrics:
    servers:
      - url: https://api.coinmetrics.io/v4
      - url: https://community-api.coinmetrics.io/v4
    get:
      tags:
        - Timeseries
      summary: Asset metrics
      description: >-
        Returns requested metrics for specified assets.<br/><br/> Results for
        block by block metrics (`1b` frequency) are ordered by tuple `(asset,
        height, block_hash)`, all other metrics are ordered by tuple `(asset,
        time)`. You can change the sorting using `sort` query
        parameter.<br/><br/> Supported output formats are `json` (default),
        `json_stream` and `csv`. Use the `format` query parameter to override
        it.<br/> To fetch the next page of results use `next_page_url` JSON
        response field or `x-next-page-url` CSV HTTP header if
        present.<br/><br/> If multiple metrics are requested in the same time
        the strict policy for partially available metrics among requested ones
        is applied: <ul>
          <li>missing metric name in the JSON response means that the metric is "not a supported metric" for the asset and frequency while some other requested metrics are supported.</li>
          <li>`null` value of the metric means "no data in the database" while some other requested metrics have data.</li>
        </ul>
      operationId: getTimeseriesAssetMetrics
      parameters:
        - $ref: '#/components/parameters/AssetMetricsAssetId'
        - $ref: '#/components/parameters/AssetMetrics'
        - $ref: '#/components/parameters/AssetMetricsFrequency'
        - $ref: '#/components/parameters/Status'
        - $ref: '#/components/parameters/StartTimeMutuallyExclusiveWithHeightAndHash'
        - $ref: '#/components/parameters/EndTimeMutuallyExclusiveWithHeightAndHash'
        - $ref: '#/components/parameters/StartHeightMutuallyExclusiveWithTimeAndHash'
        - $ref: '#/components/parameters/EndHeightMutuallyExclusiveWithTimeAndHash'
        - $ref: '#/components/parameters/StartHash'
        - $ref: '#/components/parameters/EndHash'
        - $ref: '#/components/parameters/StartInclusive'
        - $ref: '#/components/parameters/EndInclusive'
        - $ref: '#/components/parameters/MinConfirmations'
        - $ref: '#/components/parameters/Timezone'
        - $ref: '#/components/parameters/PageSize'
        - $ref: '#/components/parameters/PagingFrom'
        - $ref: '#/components/parameters/Sort'
        - $ref: '#/components/parameters/LimitPerAsset'
        - $ref: '#/components/parameters/Pretty'
        - $ref: '#/components/parameters/ResponseFormat'
        - $ref: '#/components/parameters/NullAsZero'
        - $ref: '#/components/parameters/NextPageToken'
        - $ref: '#/components/parameters/IgnoreUnsupportedErrors'
        - $ref: '#/components/parameters/IgnoreForbiddenErrors'
      responses:
        '200':
          $ref: '#/components/responses/AssetMetrics'
        '400':
          $ref: '#/components/responses/AssetNotFound'
        '401':
          $ref: '#/components/responses/Unauthorized'
        '403':
          $ref: '#/components/responses/Forbidden'
        '414':
          $ref: '#/components/responses/UriTooLong'
      security:
        - api_key: []
      x-codeSamples:
        - lang: Shell
          label: Shell
          source: >
            curl --compressed
            "https://api.coinmetrics.io/v4/timeseries/asset-metrics?assets=btc&metrics=PriceUSD,SplyBMXNtv&start_time=2020-02-29&end_time=2020-03-01&frequency=1d&pretty=true&api_key=<your_key>"
        - lang: Python
          label: Python
          source: >
            import requests

            response =
            requests.get('https://api.coinmetrics.io/v4/timeseries/asset-metrics?assets=btc&metrics=PriceUSD,SplyBMXNtv&start_time=2020-02-29&end_time=2020-03-01&frequency=1d&pretty=true&api_key=<your_key>').json()

            print(response)
        - lang: Python
          label: Python Client
          source: >
            from coinmetrics.api_client import CoinMetricsClient

            client = CoinMetricsClient(<your_key>)


            response = client.get_asset_metrics(assets="btc",
            metrics="PriceUSD,SplyBMXNtv", start_time="2020-02-29",
            end_time="2020-03-01", frequency="1d").to_list()

            print(response)
components:
  parameters:
    AssetMetricsAssetId:
      description: >-
        Comma separated list of assets.<br/> Use the
        [/catalog-all-v2/asset-metrics](#operation/getCatalogAllV2AssetMetrics)
        endpoint for the full list of supported assets or specify asterisk (*)
        in order to get metrics for all supported assets.
      in: query
      name: assets
      required: true
      schema:
        type: array
        items:
          type: string
      explode: false
    AssetMetrics:
      description: >-
        Comma separated metrics to request time series data for.<br/>
        Information on all available metrics can be found on page
        https://coverage.coinmetrics.io/asset-metrics-v2.<br/> Use the
        [/catalog-all-v2/asset-metrics](#operation/getCatalogAllV2AssetMetrics)
        endpoint for the full list of supported metrics per asset.
      in: query
      name: metrics
      required: true
      schema:
        example:
          - AdrActCnt
          - BlkHgt
        type: array
        items:
          type: string
      explode: false
    AssetMetricsFrequency:
      description: >-
        Frequency of the metrics. Supported values are `1b` (block by block),
        `1s` (one second), `1m` (one minute), `5m` (five minutes), `10m` (ten
        minutes), `1h` (one hour), `1d` (one day), `1d-ny-close` (one day at New
        York close time). Please refer to the `/catalog-v2/asset-metrics`
        endpoint for the full list.<br/> Use the
        [/catalog-all-v2/asset-metrics](#operation/getCatalogAllV2AssetMetrics)
        endpoint for the full list of supported frequencies per asset-metric
        pair.
      in: query
      name: frequency
      schema:
        default: 1d
        example: 1b
        type: string
    Status:
      description: >-
        Which metric values do you want to see. Applicable only for "reviewable"
        metrics. You can find them in the `/catalog-v2/asset-metrics` endpoint.
      in: query
      name: status
      schema:
        default: all
        enum:
          - all
          - flash
          - reviewed
          - revised
        type: string
    StartTimeMutuallyExclusiveWithHeightAndHash:
      description: >-
        Start of the time interval.<br/> This field refers to the `time` field
        in the response.<br/> Multiple formats of ISO 8601 are supported:
        `2006-01-20T00:00:00Z`, `2006-01-20T00:00:00.000Z`,
        `2006-01-20T00:00:00.123456Z`, `2006-01-20T00:00:00.123456789Z`,
        `2006-01-20`, `20060120`.<br/> Inclusive by default. Mutually exclusive
        with `start_height` and `start_hash`.<br/> UTC timezone by default. `Z`
        suffix is optional and `timezone` parameter has a priority over it.<br/>
        If `start_time` is omitted, response will include time series from the
        **earliest** time available.
      in: query
      name: start_time
      schema:
        type: string
    EndTimeMutuallyExclusiveWithHeightAndHash:
      description: >-
        End of the time interval.<br/> This field refers to the `time` field in
        the response.<br/> Multiple formats of ISO 8601 are supported:
        `2006-01-20T00:00:00Z`, `2006-01-20T00:00:00.000Z`,
        `2006-01-20T00:00:00.123456Z`, `2006-01-20T00:00:00.123456789Z`,
        `2006-01-20`, `20060120`.<br/> Inclusive by default. Mutually exclusive
        with `end_height` and `end_hash`.<br/> UTC timezone by default. `Z`
        suffix is optional and `timezone` parameter has a priority over it.<br/>
        If `end_time` is omitted, response will include time series up to the
        **latest** time available.
      in: query
      name: end_time
      schema:
        type: string
    StartHeightMutuallyExclusiveWithTimeAndHash:
      description: >-
        The start height indicates the beginning block height for the set of
        data that are returned.<br/> Inclusive by default. Mutually exclusive
        with `start_time` and `start_hash`.
      in: query
      name: start_height
      schema:
        type: integer
        format: int64
        minimum: 0
    EndHeightMutuallyExclusiveWithTimeAndHash:
      description: >-
        The end height indicates the ending block height for the set of data
        that are returned.<br/> Inclusive by default. Mutually exclusive with
        `end_time` and `end_hash`.<br/> This parameter is disabled for Community
        users.
      in: query
      name: end_height
      schema:
        type: integer
        format: int64
        minimum: 0
    StartHash:
      description: >-
        The start hash indicates the beginning block height for the set of data
        that are returned.<br/> Inclusive by default. Mutually exclusive with
        `start_time` and `start_height`.
      in: query
      name: start_hash
      schema:
        type: string
    EndHash:
      description: >-
        The end hash indicates the ending block height for the set of data that
        are returned.<br/> Inclusive by default. Mutually exclusive with
        `end_time` and `end_height`.
      in: query
      name: end_hash
      schema:
        type: string
    StartInclusive:
      description: Inclusive or exclusive corresponding `start_*` parameters.
      in: query
      name: start_inclusive
      schema:
        default: true
        type: boolean
    EndInclusive:
      description: Inclusive or exclusive corresponding `end_*` parameters.
      in: query
      name: end_inclusive
      schema:
        default: true
        type: boolean
    MinConfirmations:
      description: >-
        Specifies how many blocks behind the chain tip block by block metrics
        (`1b` frequency) are based on. Default for `btc` is `2` and `99` for
        `eth`. For example, a `min_confirmations` of `0` means metrics are being
        calculated for the block at the tip of the chain (the latest block
        received by our node) whereas a `min_confirmations` of `6` means that
        metrics are being applied to the block that is `6` blocks behind the
        chain tip (i.e., the 7th block if the chain tip is block 1).
      in: query
      name: min_confirmations
      schema:
        type: integer
        format: int32
        minimum: 0
        maximum: 99
    Timezone:
      description: >-
        Timezone name for `start_time` and `end_time` timestamps.<br/> This
        parameter does not modify the output times, which are always `UTC`.<br/>
        Format is defined by [TZ
        database](https://en.wikipedia.org/wiki/List_of_tz_database_time_zones).
      in: query
      name: timezone
      schema:
        example: America/New_York
        default: UTC
        type: string
    PageSize:
      description: >-
        Number of items per single page of results.<br/> The value of this
        parameter is ignored if the endpoint supports the `format` parameter and
        its value is set to `json_stream`.
      in: query
      name: page_size
      schema:
        default: 100
        type: integer
        format: int32
        minimum: 1
        maximum: 10000
    PagingFrom:
      description: >-
        Where does the first page start, at the start of the interval or at the
        end.<br/> The value of this parameter is ignored if the endpoint
        supports the `format` parameter and its value is set to `json_stream`.
      in: query
      name: paging_from
      schema:
        default: end
        enum:
          - start
          - end
        type: string
        format: PagingFrom
    Sort:
      description: >-
        How results will be sorted. Metrics with `1b` frequency are sorted by
        `(asset, height, block_hash)` tuples by default. Metrics with other
        frequencies are sorted by `(asset, time)` by default. If you want to
        sort `1d` metrics by `(time, asset)` you should choose `time` as value
        for the `sort` parameter.<br/> Sorting by `time` is useful if you
        request metrics for a set of assets.
      in: query
      name: sort
      schema:
        default: asset
        enum:
          - asset
          - height
          - time
        type: string
    LimitPerAsset:
      description: >-
        How many entries per asset result should contain. For example, this
        combination of parameters
        `assets=btc,eth&metrics=ReferenceRate&limit_per_asset=1` returns the
        latest `ReferenceRate` values for `btc` and `eth`.
      in: query
      name: limit_per_asset
      schema:
        type: integer
        format: int32
    Pretty:
      description: Human-readable formatting of JSON responses.
      in: query
      name: pretty
      schema:
        type: boolean
        default: false
    ResponseFormat:
      description: >-
        Format of the response. Supported values are `json`, `json_stream`,
        `csv`.
      in: query
      name: format
      schema:
        enum:
          - json
          - json_stream
          - csv
        type: string
        default: json
    NullAsZero:
      description: Nulls are represented as zeros in the response.
      in: query
      name: null_as_zero
      schema:
        type: boolean
        default: false
    NextPageToken:
      description: >-
        Token for receiving the results from the next page of a query.<br/>
        Should not be used directly. To iterate through pages just use
        `next_page_url` response field.
      in: query
      name: next_page_token
      schema:
        type: string
    IgnoreUnsupportedErrors:
      description: >-
        Ignore "unsupported" errors for not currently supported by Coin Metrics
        items.
      in: query
      name: ignore_unsupported_errors
      schema:
        type: boolean
        default: false
    IgnoreForbiddenErrors:
      description: >-
        Ignore "forbidden" errors for the items you currently don't have access
        to.
      in: query
      name: ignore_forbidden_errors
      schema:
        type: boolean
        default: false
  responses:
    AssetMetrics:
      description: Time series of metrics for an asset.
      content:
        application/json:
          examples:
            daily_metrics:
              summary: Example of a message with daily metrics.
              value:
                data:
                  - asset: btc
                    time: '2020-02-29T00:00:00.000000000Z'
                    PriceUSD: '8582.09029964933'
                    SplyBMXNtv: '283220.10827406'
                    SplyBMXNtv-status: reviewed
                    SplyBMXNtv-status-time: '2020-03-01T09:59:13.847251000Z'
                  - asset: btc
                    time: '2020-03-01T00:00:00.000000000Z'
                    PriceUSD: '8541.77389392169'
                    SplyBMXNtv: '284691.32323907'
                    SplyBMXNtv-status: reviewed
                    SplyBMXNtv-status-time: '2020-03-02T14:00:02.622168000Z'
                next_page_token: 0.MjAyMC0wNi0wN1QwMDowMDowMFo,MjAyMC0wNi0wN1QwMDowMDowMFo
                next_page_url: >-
                  https://api.coinmetrics.io/v4/timeseries/asset-metrics?api_key=<your_key>&pretty=true&assets=btc&metrics=SplyBMXNtv,PriceUSD&page_size=2&next_page_token=0.MjAyMC0wNi0wN1QwMDowMDowMFo,MjAyMC0wNi0wN1QwMDowMDowMFo
            block_by_block_metrics:
              summary: Example of a message with block by block metrics.
              value:
                data:
                  - block_hash: >-
                      0000000000000000000b7ee9ded84d26167a13c8377cd003fb344584368ba7e9
                    parent_block_hash: >-
                      0000000000000000000fd3f882c12258b3c604c724fe2e9747e250b094b8b026
                    height: '635276'
                    asset: btc
                    time: '2020-06-18T10:37:23.000000000Z'
                    FlowTfrToExCnt: '374'
                    FlowTfrToExCnt-status: flash
                    FlowTfrToExCnt-status-time: '2020-06-18T10:38:47.586052000Z'
                    PriceUSD: '9435.03'
                  - block_hash: >-
                      00000000000000000004be53922df7ddf7efc5ed5c45fdf48ccc92eb7f4df30b
                    parent_block_hash: >-
                      0000000000000000000b7ee9ded84d26167a13c8377cd003fb344584368ba7e9
                    height: '635277'
                    asset: btc
                    time: '2020-06-18T11:07:58.000000000Z'
                    FlowTfrToExCnt: '325'
                    FlowTfrToExCnt-status: flash
                    FlowTfrToExCnt-status-time: '2020-06-18T11:09:15.174316000Z'
                    PriceUSD: '9441.84'
                next_page_token: 0.NjM1Mjc2,NjM1Mjc2
                next_page_url: >-
                  https://api.coinmetrics.io/v4/timeseries/asset-metrics?api_key=<your_key>&pretty=true&assets=btc&metrics=FlowTfrToExCnt,PriceUSD&page_size=2&frequency=1b&next_page_token=0.NjM1Mjc2,NjM1Mjc2
            by_second_frequency_metrics:
              summary: Example of a message with 1s metrics.
              value:
                data:
                  - asset: btc
                    time: '2020-06-18T11:36:09.000000000Z'
                    ReferenceRate: '9431.1200000000008'
                  - asset: btc
                    time: '2020-06-18T11:36:10.000000000Z'
                    ReferenceRate: '9431.1200000000008'
                next_page_token: 0.MjAyMC0wNi0xOFQxMTozNjowOVo
                next_page_url: >-
                  https://api.coinmetrics.io/v4/timeseries/asset-metrics?api_key=<your_key>&pretty=true&assets=btc&metrics=ReferenceRate&page_size=2&frequency=1s&next_page_token=0.MjAyMC0wNi0xOFQxMTozNjowOVo
          schema:
            $ref: '#/components/schemas/AssetMetricsResponse'
        text/csv:
          example: >-
            asset,time,PriceUSD,SplyBMXNtv,SplyBMXNtv-status,SplyBMXNtv-status-time

            btc,2020-02-29T00:00:00.000000000Z,8582.09029964933,283220.10827406,reviewed,2020-03-01T09:59:13.847251000Z

            btc,2020-03-01T00:00:00.000000000Z,8541.77389392169,284691.32323907,reviewed,2020-03-02T14:00:02.622168000Z

            btc,2020-03-02T00:00:00.000000000Z,8906.21475645821,284962.29021857,reviewed,2020-03-03T14:24:11.689979000Z
          schema:
            $ref: '#/components/schemas/AssetMetricsResponse'
    AssetNotFound:
      content:
        application/json:
          example:
            error:
              type: bad_parameter
              message: Bad parameter 'assets'. Value 'sdvwbtc' is not supported.
          schema:
            $ref: '#/components/schemas/ErrorResponse'
      description: Asset not found.
    Unauthorized:
      description: Requested resource requires authorization.
      content:
        application/json:
          examples:
            unauthorized:
              summary: Unauthorized error response.
              value:
                error:
                  type: unauthorized
                  message: Requested resource requires authorization.
            wrong_credentials:
              summary: Wrong credentials error response.
              value:
                error:
                  type: wrong_credentials
                  message: Supplied credentials are not valid.
          schema:
            $ref: '#/components/schemas/ErrorResponse'
    Forbidden:
      content:
        application/json:
          example:
            error:
              type: forbidden
              message: >-
                Requested metric 'SplyBMXNtv' with frequency '1d' for asset
                'btc' is not available with supplied credentials.
          schema:
            $ref: '#/components/schemas/ErrorResponse'
      description: Requested resource is not available with supplied credentials.
    UriTooLong:
      description: Provided URI is too long. It must not be greater than 10000 symbols.
  schemas:
    AssetMetricsResponse:
      description: Time series of asset metrics.
      properties:
        data:
          items:
            type: object
            properties:
              asset:
                $ref: '#/components/schemas/Asset'
              time:
                $ref: '#/components/schemas/Time'
            additionalProperties:
              nullable: true
              description: >-
                Metric value. `null` value is only possible when multiple
                metrics are requested, but not all are calculated for now.
                Absent metric field is only possible when multiple metrics are
                requested, but not all are supported for requested assets.
              type: string
            required:
              - asset
              - time
        next_page_token:
          $ref: '#/components/schemas/NextPageToken'
        next_page_url:
          $ref: '#/components/schemas/NextPageUrl'
      required:
        - data
      type: object
    ErrorResponse:
      properties:
        error:
          $ref: '#/components/schemas/ErrorObject'
      required:
        - error
      type: object
    Asset:
      description: Name of the asset.
      type: string
    Time:
      description: >-
        The time in ISO 8601 date-time format. Always with nanoseconds
        precision.
      type: string
      format: date-time
    NextPageToken:
      description: Token of the next page results for a given request.
      type: string
    NextPageUrl:
      description: URL of the next page results for a given request.
      type: string
    ErrorObject:
      properties:
        type:
          description: Error type string. Can be used for error identification.
          type: string
        message:
          description: >-
            Human-friendly error description. Can be amended without prior
            notification. Do not use for error identification in your code.
          type: string
      required:
        - type
        - description
      type: object
  securitySchemes:
    api_key:
      description: Coin Metrics API key can be specified as `?api_key=` query parameter.
      in: query
      name: api_key
      type: apiKey

````